#ifndef	_COMMON_INC_
#define	_COMMON_INC_ 1

#include	<avr/io.h>
#ifdef _SFR_IO8
#undef _SFR_IO8
#endif
#define _SFR_IO8(x) (x)

#ifdef _SFR_IO16
#undef _SFR_IO16
#endif
#define _SFR_IO16(x) (x)

#include	"config.inc"

.macro	LDX	LBL
	CLR 	XH
	LDI 	XL,lo8(\LBL)
.endm

.macro	LDY	LBL
	CLR 	YH
	LDI 	YL,lo8(\LBL)
.endm

.macro	LDZ	LBL
	LDI 	ZH,hi8(\LBL)
	LDI 	ZL,lo8(\LBL)
.endm

.macro	ADDZ	reg
	ADD 	ZL, \reg
	BRCC	.+2
	INC 	ZH
.endm

.macro	TBLJMP	LBL,reg
	LDI 	ZH,hi8(\LBL)
	LDI 	ZL,lo8(\LBL)
	CLC
	ROR 	ZH
	ROR 	ZL
	ADDZ	\reg
	IJMP
.endm


.macro	VAR	lbl
.global	\lbl
\lbl:
.endm

.macro	BEGIN	lbl
.global	\lbl
.func	\lbl
\lbl:
.endm

.macro	RETURN
	RET
.endfunc
.endm

.macro	ENDFN
.endfunc
.endm

#define save_sreg	r0
#define zero_reg	r1

#endif	/* _COMMON_INC_ */
