; SW_LED.S
;  input port SWs and output LEDs w/PB3-0 routine
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html
;
#include	"common.inc"

;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

; =r24SW_STAT
; PB3..0 ɤ߼ r24β̥˥֥ꤷ֤
; PB3..PB0PB3..PB0γƥӥåȤξ֤ۤʤä 
; PB3..PB0PB3..PB0 ƥӥåȤξ֤Ʊˤϡ
; ܥѲӥåȤȤơr24ξ̥˥֥ꤷ֤
; Ĥޤξ֤ܥ֤Ѳ ġ
; ֤ˤʤäӥåȤ̥˥֥ꤵ롣
;
; LEDOUT(GPIOR1)Ǥβ̥˥֥ȿžơPB3..PB0 ˽Ϥ롣
; (ϡåȤ줿ӥåȰ֤LEḌ)
;
; ƾ֤ΰ̣ϥӥåȤå'1'ƤON(ܥ󲡲, LED) ꥢ'0'
; ʤ餽εդǤ롣
; ܥSWξ֤ͤSW_STAT(GPIOR2)ꤵ롣
; I2C_IFΥϡɤͤǤϡܥ󲡲/LEDǤ'0'ܥ/LEDǤ
; '1'Ǥ롣
;
;  PB3..PB0 CLCDȷѤ4bitݡȤǤΤݡȤζαդ뤳ȡ
; (ؿϡ/¾бƤʤ!!)
;
BEGIN	_SW_LED 	; BYTE SW_LED(void); // REG:r25-22
	CLI
	IN  	r25, PORTB
	ANDI	r25, 0xf0		; PB3..0 PU off	and dis-charge
	OUT 	PORTB, r25
	SEI

	RCALL	_BUS_RD         // r25
	SW_LED_EN

	IN  	r23, PINB
	COM 	r23		; inverse SW_status
	ANDI	r23, 0x0f		; SW_ in

	IN  	r24, LEDOUT
//	COM 	r24		; inverse LED_status

	CLI
	IN  	r22, PORTB
	ORI 	r22, 0x0f
	COM 	r24
	ORI 	r24, 0xf0
	AND 	r24, r22
	OUT 	PORTB, r24		; LED out
	SEI

	RCALL	_BUS_WR         // r25

; add effection previous status
;	; SW_STAT(n-2) XOR SW_STAT(n-1) 
	MOV 	r24, PREV_SW_STAT
	MOV 	r25, r24
	SWAP	r24
	EOR 	r24, r25
;	; NOT (SW_STAT(n-1) XOR SW_STAT(n) )
	MOV 	r25, PREV_SW_STAT
	EOR 	r25, r23
	COM 	r25
	ANDI	r25,0x0f
;	; (SW_STAT(n-2) XOR SW_STAT(n-1)) AND (NOT (SW_STAT(n-1) XOR SW_STAT(n) ))
	AND 	r24, r25
	SWAP	r24
	OR  	r24, r23		; return SW status into r24
	OUT 	SW_STAT, r24

	ANDI	r24, 0xf0
	BREQ	2f
	SBI 	updateFLG, updateSW
2:
	IN  	r24, SW_STAT

;update previous status
	ANDI	r23, 0x0f
	MOV 	r25, PREV_SW_STAT
	SWAP	r25
	ANDI	r25, 0xf0
	OR  	r25, r23
	MOV 	PREV_SW_STAT, r25

RETURN


.end
